"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemodMessage = exports.Message = void 0;
const react_1 = require("@chakra-ui/react");
const md_1 = require("react-icons/md");
const js_fetch_api_1 = require("@giphy/js-fetch-api");
const react_components_1 = require("@giphy/react-components");
const wallet_adapter_react_1 = require("@solana/wallet-adapter-react");
const chat_1 = require("@strata-foundation/chat");
const react_2 = require("@strata-foundation/react");
const spl_utils_1 = require("@strata-foundation/spl-utils");
const moment_1 = __importDefault(require("moment"));
const react_3 = __importStar(require("react"));
const react_async_hook_1 = require("react-async-hook");
const bs_1 = require("react-icons/bs");
const md_2 = require("react-icons/md");
const sanitize_html_1 = __importDefault(require("sanitize-html"));
const constants_1 = require("../constants");
const contexts_1 = require("../contexts");
const hooks_1 = require("../hooks");
const _1 = require("./");
const BuyMoreButton_1 = require("./BuyMoreButton");
const gf = new js_fetch_api_1.GiphyFetch(constants_1.GIPHY_API_KEY);
function fetchGif(gifyId) {
    return __awaiter(this, void 0, void 0, function* () {
        if (gifyId) {
            const { data } = yield gf.gif(gifyId);
            return data;
        }
    });
}
function GifyGif({ gifyId }) {
    const { result: data, loading } = (0, react_async_hook_1.useAsync)(fetchGif, [gifyId]);
    if (loading || !data) {
        return react_3.default.createElement(react_1.Skeleton, { w: "300px", h: "300px" });
    }
    return react_3.default.createElement(react_components_1.Gif, { gif: data, width: 300 });
}
const defaultOptions = {
    allowedTags: ["b", "i", "em", "strong", "a", "code", "ul", "li", "p"],
    allowedAttributes: {
        a: ["href", "target"],
    },
};
function ProfileName({ sender }) {
    const { info: profile } = (0, hooks_1.useWalletProfile)(sender);
    const { username } = (0, hooks_1.useUsernameFromIdentifierCertificate)(profile === null || profile === void 0 ? void 0 : profile.identifierCertificateMint, sender);
    const name = username || (sender && (0, react_2.truncatePubkey)(sender));
    return react_3.default.createElement(react_1.Text, null,
        name,
        " ");
}
const MAX_MENTIONS_DISPLAY = 3;
function Message(props) {
    const { id: messageId, getDecodedMessage, sender, readPermissionAmount, chatKey, txids, startBlockTime, htmlAllowlist = defaultOptions, reacts, type: messageType, showUser = true, pending = false, reply, scrollToMessage, } = props;
    const { publicKey } = (0, wallet_adapter_react_1.useWallet)();
    const { referenceMessageId: emojiReferenceMessageId, showPicker } = (0, contexts_1.useEmojis)();
    const { info: profile } = (0, hooks_1.useWalletProfile)(sender);
    const { username, loading: loadingUsername } = (0, hooks_1.useUsernameFromIdentifierCertificate)(profile === null || profile === void 0 ? void 0 : profile.identifierCertificateMint, sender);
    const name = (0, react_3.useMemo)(() => username || (sender && (0, react_2.truncatePubkey)(sender)), [username, sender === null || sender === void 0 ? void 0 : sender.toBase58()]);
    const { cluster } = (0, react_2.useEndpoint)();
    const { info: chat } = (0, hooks_1.useChat)(chatKey);
    const time = (0, react_3.useMemo)(() => {
        if (startBlockTime) {
            const t = new Date(0);
            t.setUTCSeconds(startBlockTime);
            return t;
        }
    }, [startBlockTime]);
    const readMint = chat === null || chat === void 0 ? void 0 : chat.readPermissionKey;
    const mintAcc = (0, react_2.useMint)(readMint);
    const { metadata } = (0, react_2.useTokenMetadata)(readMint);
    const tokenAmount = mintAcc &&
        readPermissionAmount &&
        (0, spl_utils_1.humanReadable)(readPermissionAmount, mintAcc);
    const { amount: ownedAmount } = (0, hooks_1.useChatOwnedAmount)(publicKey || undefined, chatKey);
    const notEnoughTokens = (0, react_3.useMemo)(() => {
        return (readPermissionAmount &&
            mintAcc &&
            (ownedAmount || 0) < (0, spl_utils_1.toNumber)(readPermissionAmount, mintAcc));
    }, [readPermissionAmount, mintAcc, ownedAmount]);
    // Re decode if not enough tokens changes
    const getDecodedMessageOrIdentity = (_) => getDecodedMessage ? getDecodedMessage() : Promise.resolve(undefined);
    const { result: message, loading: decoding, error: decodeError, } = (0, react_async_hook_1.useAsync)(getDecodedMessageOrIdentity, [notEnoughTokens]);
    const status = pending ? "Pending" : "Confirmed";
    const lockedColor = (0, react_1.useColorModeValue)("gray.400", "gray.600");
    const highlightedBg = (0, react_1.useColorModeValue)("gray.200", "gray.800");
    const files = (0, react_3.useMemo)(() => [
        ...((message === null || message === void 0 ? void 0 : message.attachments) || []),
        ...((message === null || message === void 0 ? void 0 : message.decryptedAttachments) || []),
    ], [message]);
    const { reacts: inflatedReacts, error: reactError, loading: reactsLoading, } = (0, hooks_1.useInflatedReacts)(reacts);
    const { handleErrors } = (0, react_2.useErrorHandler)();
    const { sendMessage, error } = (0, hooks_1.useSendMessage)({
        chatKey,
    });
    handleErrors(error, decodeError, reactError);
    const handleOnReaction = (0, react_3.useCallback)(() => {
        showPicker(messageId);
    }, [showPicker, messageId]);
    const { showReply, replyMessage } = (0, contexts_1.useReply)();
    const handleOnReply = (0, react_3.useCallback)(() => {
        showReply(props);
    }, [showReply, messageId]);
    const bg = (0, react_3.useMemo)(() => messageId === emojiReferenceMessageId || messageId === (replyMessage === null || replyMessage === void 0 ? void 0 : replyMessage.id)
        ? highlightedBg
        : "initial", [highlightedBg, emojiReferenceMessageId, messageId, replyMessage === null || replyMessage === void 0 ? void 0 : replyMessage.id]);
    const hover = (0, react_3.useMemo)(() => ({ bg: highlightedBg }), [highlightedBg]);
    const iconButtonDark = (0, react_3.useMemo)(() => ({
        bg: "gray.900",
        _hover: {
            bg: highlightedBg,
        },
    }), [highlightedBg]);
    const textColor = (0, react_1.useColorModeValue)("black", "white");
    const loadingSkeleton = (0, react_3.useMemo)(() => {
        return (react_3.default.createElement(react_1.Skeleton, { startColor: lockedColor, height: "20px" }, Array.from({ length: genLength(messageId || "") }, () => ".").join()));
    }, [messageId, lockedColor]);
    const buyMoreTrigger = (0, react_3.useCallback)((props) => {
        return (react_3.default.createElement(react_1.Tooltip, { label: `You need ${tokenAmount} ${metadata === null || metadata === void 0 ? void 0 : metadata.data.symbol} to read this message` },
            react_3.default.createElement(react_1.HStack, { onClick: props.onClick, spacing: 2, _hover: { cursor: "pointer" } },
                react_3.default.createElement(react_1.Skeleton, { startColor: lockedColor, height: "20px", speed: 100000 }, Array.from({ length: genLength(messageId || "") }, () => ".").join()),
                react_3.default.createElement(react_1.Icon, { color: lockedColor, as: bs_1.BsLockFill }))));
    }, [tokenAmount, metadata, lockedColor, messageId]);
    const tokens = (0, react_3.useMemo)(() => [chat === null || chat === void 0 ? void 0 : chat.readPermissionKey, chat === null || chat === void 0 ? void 0 : chat.postPermissionKey].filter(react_2.truthy), [chat === null || chat === void 0 ? void 0 : chat.readPermissionKey, chat === null || chat === void 0 ? void 0 : chat.postPermissionKey]);
    const handleConfirmationClick = (0, react_3.useCallback)(() => {
        txids === null || txids === void 0 ? void 0 : txids.forEach((tx) => {
            window.open(`https://explorer.solana.com/tx/${tx}?cluster=${cluster}`);
        });
    }, [txids, cluster]);
    // LEGACY: If this is a reaction before message types were stored on the top level instead of json
    if ((message === null || message === void 0 ? void 0 : message.type) === chat_1.MessageType.React) {
        return null;
    }
    return (react_3.default.createElement(react_1.Box, { position: "relative", _hover: hover, bg: bg },
        react_3.default.createElement(react_1.Popover, { matchWidth: true, trigger: "hover", placement: "top-end", isLazy: true },
            react_3.default.createElement(react_1.PopoverContent, { w: "full", bg: "transparent", border: "none" },
                react_3.default.createElement(react_1.PopoverBody, null,
                    react_3.default.createElement(_1.Flex, { direction: "row", top: 2, right: 20, justifyContent: "end", position: "absolute" },
                        react_3.default.createElement(react_1.ButtonGroup, { size: "lg", isAttached: true, variant: "outline" },
                            react_3.default.createElement(react_1.IconButton, { borderRight: "none", icon: react_3.default.createElement(react_1.Icon, { as: md_2.MdOutlineAddReaction }), w: "32px", h: "32px", variant: "outline", size: "lg", "aria-label": "Add Reaction", bg: "white", _dark: iconButtonDark, onClick: handleOnReaction }),
                            react_3.default.createElement(react_1.IconButton, { icon: react_3.default.createElement(react_1.Icon, { as: md_1.MdReply }), w: "32px", h: "32px", variant: "outline", size: "lg", "aria-label": "Reply", bg: "white", _dark: iconButtonDark, onClick: handleOnReply }))))),
            react_3.default.createElement(react_1.PopoverTrigger, null,
                react_3.default.createElement(react_1.VStack, { spacing: 0, gap: 0, w: "full" },
                    reply && (react_3.default.createElement(_1.DisplayReply, { reply: reply, htmlAllowList: htmlAllowlist, scrollToMessage: scrollToMessage })),
                    react_3.default.createElement(react_1.HStack, { pl: 2, pr: 2, pb: 1, pt: reply ? 0 : 1, w: "full", align: "start", spacing: 2, className: "strata-message" },
                        showUser ? (react_3.default.createElement(react_1.Avatar, { mt: "6px", size: "sm", src: profile === null || profile === void 0 ? void 0 : profile.imageUrl })) : (react_3.default.createElement(react_1.Box, { w: "34px" })),
                        react_3.default.createElement(react_1.VStack, { w: "full", align: "start", spacing: 0 },
                            showUser && (react_3.default.createElement(react_1.HStack, { alignItems: "center" },
                                react_3.default.createElement(react_1.Text, { fontSize: "sm", fontWeight: "semibold", color: "green.500", _dark: { color: "green.200" } }, name),
                                showUser && (react_3.default.createElement(react_1.Show, { below: "md" },
                                    react_3.default.createElement(react_1.Text, { fontSize: "xs", color: "gray.500", _dark: { color: "gray.400" } }, (0, moment_1.default)(time).format("LT")))),
                                react_3.default.createElement(_1.TokenFlare, { chat: chatKey, wallet: sender, tokens: tokens }))),
                            react_3.default.createElement(react_1.Box, { w: "fit-content", position: "relative", textAlign: "left", wordBreak: "break-word", color: textColor, id: messageId }, message ? (messageType === chat_1.MessageType.Gify ? (react_3.default.createElement(GifyGif, { gifyId: message.gifyId })) : message.type === chat_1.MessageType.Image ? (react_3.default.createElement(_1.Files, { files: files })) : message.type === chat_1.MessageType.Text ? (react_3.default.createElement(react_1.Text, { mt: "-4px" }, message.text)) : (react_3.default.createElement(react_3.default.Fragment, null,
                                react_3.default.createElement(_1.Files, { files: files }),
                                react_3.default.createElement("div", { dangerouslySetInnerHTML: {
                                        __html: message.html
                                            ? (0, sanitize_html_1.default)(message.html, htmlAllowlist)
                                            : "",
                                    } })))) : decoding ? (loadingSkeleton) : notEnoughTokens ? (react_3.default.createElement(BuyMoreButton_1.BuyMoreButton, { mint: readMint, trigger: buyMoreTrigger })) : (react_3.default.createElement(react_1.Tooltip, { label: `Failed to decode message` },
                                react_3.default.createElement(react_1.Skeleton, { startColor: lockedColor, height: "20px", speed: 100000 }, Array.from({ length: genLength(messageId || "") }, () => ".").join())))),
                            inflatedReacts && inflatedReacts.length > 0 && (react_3.default.createElement(react_1.HStack, { mt: 2, pt: 1 },
                                inflatedReacts.map(({ emoji, messages, mine }) => (react_3.default.createElement(react_1.Popover, { matchWidth: true, trigger: "hover", key: emoji },
                                    react_3.default.createElement(react_1.PopoverTrigger, null,
                                        react_3.default.createElement(react_1.Button, { onClick: () => {
                                                if (!mine)
                                                    sendMessage({
                                                        type: chat_1.MessageType.React,
                                                        emoji: emoji,
                                                        referenceMessageId: messageId,
                                                    });
                                            }, borderLeftRadius: "20px", width: "55px", borderRightRadius: "20px", p: 0, variant: mine ? "solid" : "outline", size: "sm", key: emoji },
                                            react_3.default.createElement(react_1.HStack, { spacing: 1 },
                                                react_3.default.createElement(react_1.Text, { lineHeight: 0, fontSize: "lg" }, emoji),
                                                react_3.default.createElement(react_1.Text, { lineHeight: 0, fontSize: "sm" }, messages.length)))),
                                    react_3.default.createElement(react_1.PopoverContent, { width: "fit-content" },
                                        react_3.default.createElement(react_1.PopoverArrow, null),
                                        react_3.default.createElement(react_1.PopoverBody, null,
                                            react_3.default.createElement(react_1.HStack, { spacing: 1 },
                                                messages
                                                    .slice(0, MAX_MENTIONS_DISPLAY)
                                                    .map((message, index) => (react_3.default.createElement(react_1.HStack, { key: message.id, spacing: 0 },
                                                    react_3.default.createElement(ProfileName, { sender: message.sender }),
                                                    messages.length - 1 != index && (react_3.default.createElement(react_1.Text, null, ", "))))),
                                                messages.length > MAX_MENTIONS_DISPLAY && (react_3.default.createElement(react_1.Text, null,
                                                    "and ",
                                                    messages.length - MAX_MENTIONS_DISPLAY,
                                                    " ",
                                                    "others")))))))),
                                react_3.default.createElement(react_1.Button, { borderLeftRadius: "20px", width: "55px", borderRightRadius: "20px", variant: "outline", size: "sm", onClick: handleOnReaction },
                                    react_3.default.createElement(react_1.Icon, { as: md_2.MdOutlineAddReaction }))))),
                        react_3.default.createElement(react_1.HStack, { alignItems: "center", flexShrink: 0 },
                            showUser && (react_3.default.createElement(react_1.Hide, { below: "md" },
                                react_3.default.createElement(react_1.Text, { fontSize: "xs", color: "gray.500", _dark: { color: "gray.400" } }, (0, moment_1.default)(time).format("LT")))),
                            react_3.default.createElement(react_1.Icon, { _hover: { cursor: "pointer" }, onClick: handleConfirmationClick, w: "12px", h: "12px", as: pending ? bs_1.BsCircle : bs_1.BsCheckCircleFill, color: "gray", title: status }))))))));
}
exports.Message = Message;
const lengths = {};
function genLength(id) {
    if (!lengths[id]) {
        lengths[id] = 10 + Math.random() * 100;
    }
    return lengths[id];
}
exports.MemodMessage = react_3.default.memo(Message);
//# sourceMappingURL=Message.js.map