import { PublicKey } from "@solana/web3.js";
import { IMessage } from "@strata-foundation/chat";
export interface IMessageWithPending extends IMessage {
    pending?: boolean;
}
export interface IMessageWithPendingAndReacts extends IMessage {
    reacts: IMessageWithPending[];
    reply: IMessageWithPending | null;
}
export interface IUseMessages {
    error: Error | undefined;
    hasMore: boolean;
    loadingInitial: boolean;
    loadingMore: boolean;
    messages: IMessageWithPendingAndReacts[] | undefined;
    fetchMore(num: number): void;
    fetchNew(num: number): void;
}
export declare function useMessages(chat: PublicKey | undefined, accelerated?: boolean, numTransactions?: number): IUseMessages;
//# sourceMappingURL=useMessages.d.ts.map